
#ifndef EQ_H
#define EQ_H


#include "readData.h"
#include "generalization.h"


struct equivalenceTuple_s
{
	dimension *content;
	int noOfMember;
	int noOfSen;
	int *member;
	int *isSen;

	// newly added
	int id;
};
typedef struct equivalenceTuple_s equivalenceTuple;

struct equivalenceClass_s
{
	int noOfEqClass;
	equivalenceTuple **eqClass;
};
typedef struct equivalenceClass_s equivalenceClass;

extern FILE *g_debugFilePtr;


int ceiling(double no);
void progressiveMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable);
int isAlphaKAnonymity_EquivalenceClass(equivalenceTuple *eqOne, configure *conf);

extern double calculateDistortion(equivalenceClass *eqClass, configure *config, generalizedAllTable *genAllTable);
extern int calculateGreatestPossRemovalCount(equivalenceClass *eqClass, configure *conf);
extern int chooseBestAttribute(equivalenceClass *eqClass, data *dataSet, configure *conf);
extern void generalizeEqClass(equivalenceClass *eqClass, int attrNo, configure *conf, generalizedAllTable *genAllTable);

float calculateDistanceBetweenEquivalenceTuple(configure *conf, generalizedAllTable *genAllTable, equivalenceTuple *eqTuple1, equivalenceTuple *eqTuple2);

void insertEqTupleIntoEqClass(equivalenceClass *eqClass, equivalenceTuple *eqTuple);
void removeEqTupleFromEqClass(equivalenceClass *eqClass, int index);

equivalenceTuple *mergeTwoEquivalenceTuple(int noOfDim, generalizedAllTable *genAllTable, equivalenceTuple *eqTuple1, equivalenceTuple *eqTuple2);

void hierachicalMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable);
void randomMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable);

#endif
