

#include "readData.h"


extern void generalizeDimension(dimension *dim, generalizedLevelTable *genLevelTable);

void prepProcessDataSet(data *dataSet, int K, generalizedAllTable *genAllTable)
{
	int i, j;

	int **hist;

	tuple *tupleList;
	dimension *dim;

	int level, value;

	int noOfDim, noOfTuple, dimSize;

	int *isGeneralize;

	generalizedDimTable *genDimTable;
	generalizedLevelTable *genLevelTable;

	int isFinish;



	

	noOfDim = dataSet->noOfDim;
	noOfDim = noOfDim-1;
	noOfTuple = dataSet->noOfTuple;

	hist = (int **) malloc(sizeof(int *)*noOfDim);
	for (i = 0; i < noOfDim; i++)
	{
		dimSize = dataSet->dimSize[i];
		hist[i] = (int *) malloc(sizeof(int)*dimSize);
	}



	isGeneralize = (int *) malloc(sizeof(int)*noOfDim);
	
	
	tupleList = dataSet->tupleList;

	isFinish = 0;
	while (isFinish == 0)
	{
		for (i = 0; i < noOfDim; i++)
		{
			genDimTable = &(genAllTable->genDimTable[i]);

			// assume at least one tuple
			level = tupleList[0].content[i].level;
			if (level < genDimTable->noOfLevel)
			{
				dimSize = genDimTable->gen[level].noOfPoss;
				memset(hist[i], 0, sizeof(int)*dimSize);
			}
		}

		// count the distribution
		for (i = 0; i < noOfTuple; i++)
		{
			for (j = 0; j < noOfDim; j++)
			{
				dim = &(tupleList[i].content[j]);

				level = dim->level;
				value = dim->value;

				// increment
				hist[j][value]++;
			}
		}

		// is generalize
		memset(isGeneralize, 0, sizeof(int)*noOfDim);
		for (i = 0; i < noOfDim; i++)
		{
			// assume at least one tuple
			level = tupleList[0].content[i].level;
			if (level < genDimTable->noOfLevel)
			{
				dimSize = genDimTable->gen[level].noOfPoss;
				for (j = 0; j < dimSize; j++)
				{
					if ((hist[i][j] < K) && (hist[i][j] > 0))
					{
						//
						isGeneralize[i] = 1;
						break;
					}
				}
			}
			
		}

		// generalize
		for (i = 0; i < noOfTuple; i++)
		{
			for (j = 0; j < noOfDim; j++)
			{
				if (isGeneralize[j] == 1)
				{
					dim = &(tupleList[i].content[j]);
					level = dim->level;

					genDimTable = &(genAllTable->genDimTable[j]);
					if (level < genDimTable->noOfLevel)
					{
						genLevelTable = &(genDimTable->gen[level]);

						generalizeDimension(dim, genLevelTable);
					}
				}
			}
		}

		isFinish = 1;
		for (i = 0; i < noOfDim; i++)
		{
			if (isGeneralize[i] == 1)
			{
				isFinish = 0;
				break;
			}
		}
	}

	free(isGeneralize);

	// free
	for (i = 0; i < noOfDim; i++)
	{
		free(hist[i]);
	}
	free(hist);
}


data *readData(configure *config)
{
	data *returnValue;
	FILE *dataFilePtr;
	FILE *dimFilePtr;

	int i, j;

	char *dataFilename; 
	char *dimFilename;
	int noOfTuple;
	int noOfDim;


	dataFilename = config->dataFilename;
	dimFilename = config->dimFilename;
	noOfTuple = config->noOfTuple;
	noOfDim = config->noOfDim;

	dataFilePtr = (FILE *) fopen(dataFilename, "r");
	if (dataFilePtr == NULL)
	{
		printf("File %s does not exist!\n", dataFilename);
		exit(0);
	}

	dimFilePtr = (FILE *) fopen(dimFilename, "r");
	if (dimFilePtr == NULL)
	{
		printf("File %s does not exist!\n", dimFilename);
		exit(0);
	}

	returnValue = (data *) malloc(sizeof(data));

	returnValue->noOfDim = noOfDim;
	returnValue->noOfTuple = noOfTuple;
	returnValue->dimSize = (int *) malloc(sizeof(int)*noOfDim);
	returnValue->tupleList = (tuple *) malloc(sizeof(tuple)*noOfTuple);

	// read the dim file
	for (j = 0; j < noOfDim; j++)
	{
		fscanf(dimFilePtr, "%d ", &(returnValue->dimSize[j]));
	}

	// read the data file
	for (i = 0; i < noOfTuple; i++)
	{
		returnValue->tupleList[i].content = (dimension *) malloc(sizeof(dimension)*noOfDim);
		for (j = 0; j < noOfDim; j++)
		{
			fscanf(dataFilePtr, "%d ", &(returnValue->tupleList[i].content[j].value));
			returnValue->tupleList[i].content[j].level = 0;
		}
	}

	fclose(dimFilePtr);
	fclose(dataFilePtr);

	return returnValue;
}

int *createListFromData(data *dataSet, int noOfDim, int *dimNo)
{
	int *returnValue;

	int i, j;
	int dim;

	//int base;

	tuple *tuplePtr;

	tuplePtr = dataSet->tupleList;

	returnValue = (int *) malloc(sizeof(int)*(dataSet->noOfTuple));
	memset(returnValue, 0, sizeof(int)*(dataSet->noOfTuple));

	for (i = 0; i < dataSet->noOfTuple; i++)
	{
		for (j = 0; j < noOfDim; j++)
		{
			dim = dimNo[j];

			returnValue[i] = returnValue[i]*dataSet->dimSize[dim] + tuplePtr[i].content[dim].value;
			//tuplePtr[i].content[dim].level = ;

		}
	}

	return returnValue;
}

int *createListFromSummary(data *dataSet, summary *synopsis, int noOfDim, int *dimNo)
{
	int *returnValue;

	int i, j;
	int dim;

	group *grouping;

	grouping = synopsis->grouping;

	returnValue = (int *) malloc(sizeof(int)*(synopsis->noOfGroup));
	memset(returnValue, 0, sizeof(int)*(synopsis->noOfGroup));

	for (i = 0; i < synopsis->noOfGroup; i++)
	{
		for (j = 0; j < noOfDim; j++)
		{
			dim = dimNo[j];

			returnValue[i] = returnValue[i]*dataSet->dimSize[dim] + grouping[i].content[dim].value;
		}
	}

	return returnValue;

}



// assume the value contains non-negative no.
summary *createSummaryFromSortedValue(int *index, int *value, int noOfElt, data *dataSet)
{
	summary *returnValue;

	int i;
	int noOfGroup;
	int prevValue;

	int *groupIndex;

	group *grouping;
	dimension *content;
	dimension *dataDim;

	int noOfMember;
	int *member;

	returnValue = (summary *) malloc(sizeof(summary));

	// find no. of groups
	prevValue = -1;
	noOfGroup = 0;
	for (i = 0; i < noOfElt; i++)
	{
		if (prevValue != value[i])
		{
			noOfGroup++;
			prevValue = value[i];
		}
	}

	// malloc
	returnValue->noOfGroup = noOfGroup;
	grouping = (group *) malloc(sizeof(group)*noOfGroup);

	groupIndex = (int *) malloc(sizeof(int)*(noOfGroup+1));
	memset(groupIndex, 0, sizeof(int)*(noOfGroup+1));

	// find the group index (boundary index)
	prevValue = -1;
	noOfGroup = 0;
	for (i = 0; i < noOfElt; i++)
	{
		if (prevValue != value[i])
		{
			groupIndex[noOfGroup] = i;

			noOfGroup++;
			prevValue = value[i];
		}
	}
	groupIndex[noOfGroup] = noOfElt;

	//
	for (i = 0; i < noOfGroup; i++)
	{
		noOfMember = groupIndex[i+1]-groupIndex[i];		
		member = (int *) malloc(sizeof(int)*noOfMember);

		memcpy(member, &(index[groupIndex[i]]), sizeof(int)*noOfMember);

		content = (dimension *) malloc(sizeof(dimension)*dataSet->noOfDim);
		dataDim = dataSet->tupleList[index[groupIndex[i]]].content;
		memcpy(content, dataDim, sizeof(dimension)*dataSet->noOfDim);

		grouping[i].noOfMember = noOfMember;
		grouping[i].member = member;
		grouping[i].content = content;
		
	}

	returnValue->grouping = grouping;

	free(groupIndex);

	return returnValue;
}

summary *createSummaryFromDataSet(data *dataSet, int noOfDim, int *dimNo)
{
	summary *returnValue;
	int *index;
	int i;

	int *combineList;

	index = (int *) malloc(sizeof(int)*dataSet->noOfTuple);
	for (i = 0; i < dataSet->noOfTuple; i++)
	{
		index[i] = i;
	}

	// get the combine list
	//int *createListFromData(data *dataSet, int noOfDim, int *dimNo)
	combineList = createListFromData(dataSet, noOfDim, dimNo);

	// quick sort the combine list
	quicksort_i(index, combineList, 0, dataSet->noOfTuple-1);

	// create groups according to the sorted value
	//summary *createSummaryFromSortedValue(int *index, int *value, int noOfElt, data *dataSet)
	returnValue = createSummaryFromSortedValue(index, combineList, dataSet->noOfTuple, dataSet);



	free(combineList);
	free(index);

	return returnValue;
}


void printSummary(FILE *filePtr, summary *synopsis, int noOfDim)
{
	int i, j;

	group *list;
	group *groupOne;

	fprintf(filePtr, "---------------------------------------------\n");
	fprintf(filePtr, "No. of Groups: %d\n", synopsis->noOfGroup);
	printf("---------------------------------------------\n");
	printf("No. of Groups: %d\n", synopsis->noOfGroup);

	list = synopsis->grouping;

	for (i = 0; i < synopsis->noOfGroup; i++)
	{
		groupOne = &(list[i]);

		fprintf(filePtr, "      ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
		fprintf(filePtr, "      Group %d. \n", i);
		fprintf(filePtr, "           Value         : ");
		printf("      ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
		printf("      Group %d. \n", i);
		printf("           Value         : ");
		for (j = 0; j < noOfDim; j++)
		{
			fprintf(filePtr, "(%d %d) ", groupOne->content[j].level, groupOne->content[j].value);
			printf("(%d %d) ", groupOne->content[j].level, groupOne->content[j].value);
		}
		fprintf(filePtr, "\n");
		printf("\n");

		fprintf(filePtr, "           No. of Members: %d\n", groupOne->noOfMember);
		printf("           No. of Members: %d\n", groupOne->noOfMember);

		fprintf(filePtr, "           Members : \n");
		fprintf(filePtr, "              ");
		printf("           Members : \n");
		printf("              ");
		for (j = 0; j < groupOne->noOfMember; j++)
		{
			fprintf(filePtr, "%d ", groupOne->member[j]);
			printf("%d ", groupOne->member[j]);
		}
		fprintf(filePtr, "\n");
		printf("\n");

		fprintf(filePtr, "\n");
		printf("\n");
	}

}

summary *createSummary(data *dataSet)
{
	summary *returnValue;

	int noOfDim;
	int *dimNo;
	int i;

	noOfDim = dataSet->noOfDim;
	dimNo = (int *) malloc(sizeof(int)*noOfDim);
	for (i = 0; i < noOfDim; i++)
	{
		dimNo[i] = i;
	}
	
	//summary *createSummaryFromDataSet(data *dataSet, int noOfDim, int *dimNo)
	returnValue = createSummaryFromDataSet(dataSet, noOfDim, dimNo);
	
	free(dimNo);

	return returnValue;
}

// Assume the largest value (e.g. 2) corresponds to the sensitve value
int getNoOfSenValueFromSortedValue(int *index, int *value, int noOfElt, summary *synopsis)
{
	int returnValue;

	int prevValue;

	int noOfGroup;

	int i;

	returnValue = 0;

	// find no. of sen values
	prevValue = -1;
	noOfGroup = 0;
	if (noOfElt > 0)
	{
		returnValue += synopsis->grouping[index[0]].noOfMember;
		for (i = 0; i < noOfElt; i++)
		{
			if (prevValue != value[i])
			{
				noOfGroup++;
				prevValue = value[i];

				if (noOfGroup == 2)
				{
					//returnValue = i;
					break;
				}
			}
			else
			{
				returnValue += synopsis->grouping[index[i]].noOfMember;
			}
		}
	}

	return returnValue;
}

int summary_getNoOfSen(data *dataSet, summary *synopsis, int noOfDim, int *dimNo)
{
	int returnValue;
	int *index;

	int *combineList;
	int i;

	index = (int *) malloc(sizeof(int)*synopsis->noOfGroup);
	for (i = 0; i < synopsis->noOfGroup; i++)
	{
		index[i] = i;
	}

	// get the combine list
	combineList = createListFromSummary(dataSet, synopsis, noOfDim, dimNo);

	// quick sort the combine list
	quicksort_i(index, combineList, 0, synopsis->noOfGroup-1);

	// Assume only one sensitve attribute
	returnValue = getNoOfSenValueFromSortedValue(index, combineList, synopsis->noOfGroup, synopsis);

	free(combineList);

	return returnValue;
}

